import sys
import code
from base64 import b64decode as bdec
from seccomp import SyscallFilter, KILL, ALLOW


def activate_seccomp():
    f = SyscallFilter(KILL)
    f.add_rule_exactly(ALLOW, "read")
    f.add_rule_exactly(ALLOW, "write")
    f.add_rule_exactly(ALLOW, "close")
    f.add_rule_exactly(ALLOW, "rt_sigreturn")

    f.add_rule_exactly(ALLOW, "rt_sigaction")
    f.add_rule_exactly(ALLOW, "brk")
    f.add_rule_exactly(ALLOW, "exit")
    f.add_rule_exactly(ALLOW, "exit_group")
    f.add_rule_exactly(ALLOW, "sigaltstack")
    f.load()


sandbox = len(sys.argv) == 3

scode = bdec(sys.argv[1])
scode = scode.split(b'\n')
inter = code.InteractiveInterpreter()

if sandbox:
    activate_seccomp()
for line in scode:
    inter.runcode(line)

if sandbox:
    print(sys.argv[2])
